function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import dayjs from 'dayjs';
import groupBy from 'lodash/groupBy';
import { useState } from 'react';
import { VmFilter, VmLineCharts, VmTitle } from "../../../_components";
import { alarmService } from "../../api";
import "./index.less";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var TREND = function TREND(_ref) {
  var _ref$classPrefix = _ref.classPrefix,
    classPrefix = _ref$classPrefix === void 0 ? '' : _ref$classPrefix,
    id = _ref.id;
  var _useState = useState([dayjs().subtract(6, 'days'), dayjs()]),
    _useState2 = _slicedToArray(_useState, 2),
    times = _useState2[0],
    setTimes = _useState2[1];
  // 满溢一周趋势分布
  var mySumByGarbageTypeAndDay = alarmService.useMySumByGarbageTypeAndDay({
    housingEstateId: id,
    beginTime: times[0].format('YYYY-MM-DD 00:00:00'),
    endTime: times[1].format('YYYY-MM-DD 23:59:59')
  });
  var lineData = (mySumByGarbageTypeAndDay || []).map(function (item) {
    return {
      name: item.garbageTypeName || '',
      count: item.count || 0,
      day: item.day || ''
    };
  });
  var disabledDate = function disabledDate(current) {
    var _times = _slicedToArray(times, 2),
      startDate = _times[0],
      endDate = _times[1];
    if (!startDate || !endDate) {
      return false;
    }
    var tooLate = startDate && current.diff(startDate, 'days') > 7;
    var tooEarly = endDate && endDate.diff(current, 'days') > 7;
    return !!tooEarly || !!tooLate;
  };
  return /*#__PURE__*/_jsxs("div", {
    children: [/*#__PURE__*/_jsxs("div", {
      className: "".concat(classPrefix, "-row"),
      children: [/*#__PURE__*/_jsx(VmTitle, {
        title: "\u6EE1\u6EA2\u4E00\u5468\u53D8\u5316\u8D8B\u52BF",
        border: false
      }), /*#__PURE__*/_jsx(VmFilter.VMRangePicker, {
        value: times,
        onChange: function onChange(dates) {
          return dates && setTimes(dates);
        },
        disabledDate: disabledDate,
        style: {
          width: '280px'
        }
      })]
    }), /*#__PURE__*/_jsx(VmLineCharts, _objectSpread(_objectSpread({
      height: "250px"
    }, transferLineData(lineData)), {}, {
      // loading={loading}
      unit: "\u6B21",
      legendOption: {
        width: '95%',
        top: 24
      }
    }))]
  });
};
export default TREND;
var transferLineData = function transferLineData(data) {
  var groupByThrowPoint = groupBy(data || [], 'name');
  var groupByDay = groupBy(data || [], 'day');
  var lineData = [];
  // eslint-disable-next-line guard-for-in
  for (var key in groupByThrowPoint) {
    var item = groupByThrowPoint[key];
    lineData.push({
      name: item[0].name || '',
      data: item.map(function (item) {
        return item.count || 0;
      })
    });
  }
  // 去除日期中的年
  var xAxis = Object.keys(groupByDay).map(function (item) {
    return item.substring(5);
  });
  return {
    xAxis: xAxis,
    dataList: lineData
  };
};